Package net.sf.saxon.om

## Class ZeroOrMore<T extends Item>

- java.lang.Object
- - net.sf.saxon.om.ZeroOrMore<T>

- All Implemented Interfaces:
    `java.lang.Iterable<T>`, `GroundedValue`, `Sequence`

      public class ZeroOrMore<T extends Item>
      extends java.lang.Object
      implements GroundedValue, java.lang.Iterable<T>

  A value that is a sequence containing one or more items. The main use is in declarations of reflexive extension functions, where declaring an argument of type <ZeroOrMore<IntegerValue>> triggers automatic type checking in the same way as for a native XSLT/XQuery function declaring the type as xs:integer*.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ZeroOrMore​(java.util.List<T> content)` |
    `ZeroOrMore​(SequenceIterator iter)` |
    `ZeroOrMore​(T[] content)` | Create a sequence containing zero or one items

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value of this sequence
    `int` | `getLength()` | Get the size of the value (the number of items)
    `java.lang.String` | `getStringValue()` | Get the string value of this sequence.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the string value of this sequence.
    `T` | `head()` | Get the first item of the sequence.
    `T` | `itemAt​(int n)` | Get the n'th item in the value, counting from 0
    `ListIterator<T>` | `iterate()` | Get an iterator over all the items in the sequence.
    `java.util.Iterator<T>` | `iterator()` |
    `GroundedValue` | `reduce()` | Reduce the sequence to its simplest form.
    `ZeroOrMore<T>` | `subsequence​(int start, int length)` | Get a subsequence of the value

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### ZeroOrMore

          public ZeroOrMore​(T[] content)

      Create a sequence containing zero or one items
      Parameters:
        `content` - The content of the sequence

    - #### ZeroOrMore

          public ZeroOrMore​(java.util.List<T> content)

    - #### ZeroOrMore

          public ZeroOrMore​(SequenceIterator iter)
                     throws XPathException

      Throws:
        `XPathException`

  - ### Method Detail

    - #### head

          public T head()

      Description copied from interface: `GroundedValue`
      Get the first item of the sequence. This differs from the parent interface in not allowing an exception
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item of the sequence, or null if the sequence is empty

    - #### iterate

          public ListIterator<T> iterate()

      Description copied from interface: `GroundedValue`
      Get an iterator over all the items in the sequence. This differs from the superclass method in not allowing an exception, either during this method call, or in the subsequent processing of the returned iterator.
      Specified by:
        `iterate` in interface `GroundedValue`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator (meaning a Saxon `SequenceIterator` rather than a Java `Iterator`) over all the items in this Sequence.

    - #### iterator

          public java.util.Iterator<T> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<T extends Item>`

    - #### itemAt

          public T itemAt​(int n)

      Get the n'th item in the value, counting from 0
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the index of the required item, with 0 representing the first item in the sequence
      Returns:
        the n'th item if it exists, or null otherwise

    - #### subsequence

          public ZeroOrMore<T> subsequence​(int start,
                                           int length)

      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence.

    - #### getLength

          public int getLength()

      Get the size of the value (the number of items)
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()
                                        throws XPathException

      Get the effective boolean value of this sequence
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if the sequence has no effective boolean value (for example a sequence of two integers)

    - #### getStringValue

          public java.lang.String getStringValue()
                                          throws XPathException

      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()
                                                  throws XPathException

      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### reduce

          public GroundedValue reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of `AtomicValue`. If the value is a single item of any other kind, the result will be an instance of `One`. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence